<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for documento StructType
 * @subpackage Structs
 */
class Documento extends AbstractStructBase
{
    /**
     * The tipodocumento
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $tipodocumento;
    /**
     * The numerodocumento
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $numerodocumento;
    /**
     * The fechadocumento
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fechadocumento;
    /**
     * Constructor method for documento
     * @uses Documento::setTipodocumento()
     * @uses Documento::setNumerodocumento()
     * @uses Documento::setFechadocumento()
     * @param string $tipodocumento
     * @param string $numerodocumento
     * @param string $fechadocumento
     */
    public function __construct($tipodocumento = null, $numerodocumento = null, $fechadocumento = null)
    {
        $this
            ->setTipodocumento($tipodocumento)
            ->setNumerodocumento($numerodocumento)
            ->setFechadocumento($fechadocumento);
    }
    /**
     * Get tipodocumento value
     * @return string|null
     */
    public function getTipodocumento()
    {
        return $this->tipodocumento;
    }
    /**
     * Set tipodocumento value
     * @param string $tipodocumento
     * @return \StructType\Documento
     */
    public function setTipodocumento($tipodocumento = null)
    {
        // validation for constraint: string
        if (!is_null($tipodocumento) && !is_string($tipodocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tipodocumento)), __LINE__);
        }
        $this->tipodocumento = $tipodocumento;
        return $this;
    }
    /**
     * Get numerodocumento value
     * @return string|null
     */
    public function getNumerodocumento()
    {
        return $this->numerodocumento;
    }
    /**
     * Set numerodocumento value
     * @param string $numerodocumento
     * @return \StructType\Documento
     */
    public function setNumerodocumento($numerodocumento = null)
    {
        // validation for constraint: string
        if (!is_null($numerodocumento) && !is_string($numerodocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($numerodocumento)), __LINE__);
        }
        $this->numerodocumento = $numerodocumento;
        return $this;
    }
    /**
     * Get fechadocumento value
     * @return string|null
     */
    public function getFechadocumento()
    {
        return $this->fechadocumento;
    }
    /**
     * Set fechadocumento value
     * @param string $fechadocumento
     * @return \StructType\Documento
     */
    public function setFechadocumento($fechadocumento = null)
    {
        // validation for constraint: string
        if (!is_null($fechadocumento) && !is_string($fechadocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fechadocumento)), __LINE__);
        }
        $this->fechadocumento = $fechadocumento;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Documento
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
