<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GrabarDespacho4Response StructType
 * @subpackage Structs
 */
class GrabarDespacho4Response extends AbstractStructBase
{
    /**
     * The respuesta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $respuesta;
    /**
     * The remesa
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $remesa;
    /**
     * The URLRelacionEnvio
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $URLRelacionEnvio;
    /**
     * The URLRotulos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $URLRotulos;
    /**
     * The URLRemesa
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $URLRemesa;
    /**
     * The IMGRelacionEnvio
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IMGRelacionEnvio;
    /**
     * The IMGRotulos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IMGRotulos;
    /**
     * The IMGRemesa
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IMGRemesa;
    /**
     * The mensaje
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mensaje;
    /**
     * Constructor method for GrabarDespacho4Response
     * @uses GrabarDespacho4Response::setRespuesta()
     * @uses GrabarDespacho4Response::setRemesa()
     * @uses GrabarDespacho4Response::setURLRelacionEnvio()
     * @uses GrabarDespacho4Response::setURLRotulos()
     * @uses GrabarDespacho4Response::setURLRemesa()
     * @uses GrabarDespacho4Response::setIMGRelacionEnvio()
     * @uses GrabarDespacho4Response::setIMGRotulos()
     * @uses GrabarDespacho4Response::setIMGRemesa()
     * @uses GrabarDespacho4Response::setMensaje()
     * @param int $respuesta
     * @param string $remesa
     * @param string $uRLRelacionEnvio
     * @param string $uRLRotulos
     * @param string $uRLRemesa
     * @param string $iMGRelacionEnvio
     * @param string $iMGRotulos
     * @param string $iMGRemesa
     * @param string $mensaje
     */
    public function __construct($respuesta = null, $remesa = null, $uRLRelacionEnvio = null, $uRLRotulos = null, $uRLRemesa = null, $iMGRelacionEnvio = null, $iMGRotulos = null, $iMGRemesa = null, $mensaje = null)
    {
        $this
            ->setRespuesta($respuesta)
            ->setRemesa($remesa)
            ->setURLRelacionEnvio($uRLRelacionEnvio)
            ->setURLRotulos($uRLRotulos)
            ->setURLRemesa($uRLRemesa)
            ->setIMGRelacionEnvio($iMGRelacionEnvio)
            ->setIMGRotulos($iMGRotulos)
            ->setIMGRemesa($iMGRemesa)
            ->setMensaje($mensaje);
    }
    /**
     * Get respuesta value
     * @return int
     */
    public function getRespuesta()
    {
        return $this->respuesta;
    }
    /**
     * Set respuesta value
     * @param int $respuesta
     * @return \StructType\GrabarDespacho4Response
     */
    public function setRespuesta($respuesta = null)
    {
        // validation for constraint: int
        if (!is_null($respuesta) && !is_numeric($respuesta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($respuesta)), __LINE__);
        }
        $this->respuesta = $respuesta;
        return $this;
    }
    /**
     * Get remesa value
     * @return string|null
     */
    public function getRemesa()
    {
        return $this->remesa;
    }
    /**
     * Set remesa value
     * @param string $remesa
     * @return \StructType\GrabarDespacho4Response
     */
    public function setRemesa($remesa = null)
    {
        // validation for constraint: string
        if (!is_null($remesa) && !is_string($remesa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remesa)), __LINE__);
        }
        $this->remesa = $remesa;
        return $this;
    }
    /**
     * Get URLRelacionEnvio value
     * @return string|null
     */
    public function getURLRelacionEnvio()
    {
        return $this->URLRelacionEnvio;
    }
    /**
     * Set URLRelacionEnvio value
     * @param string $uRLRelacionEnvio
     * @return \StructType\GrabarDespacho4Response
     */
    public function setURLRelacionEnvio($uRLRelacionEnvio = null)
    {
        // validation for constraint: string
        if (!is_null($uRLRelacionEnvio) && !is_string($uRLRelacionEnvio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uRLRelacionEnvio)), __LINE__);
        }
        $this->URLRelacionEnvio = $uRLRelacionEnvio;
        return $this;
    }
    /**
     * Get URLRotulos value
     * @return string|null
     */
    public function getURLRotulos()
    {
        return $this->URLRotulos;
    }
    /**
     * Set URLRotulos value
     * @param string $uRLRotulos
     * @return \StructType\GrabarDespacho4Response
     */
    public function setURLRotulos($uRLRotulos = null)
    {
        // validation for constraint: string
        if (!is_null($uRLRotulos) && !is_string($uRLRotulos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uRLRotulos)), __LINE__);
        }
        $this->URLRotulos = $uRLRotulos;
        return $this;
    }
    /**
     * Get URLRemesa value
     * @return string|null
     */
    public function getURLRemesa()
    {
        return $this->URLRemesa;
    }
    /**
     * Set URLRemesa value
     * @param string $uRLRemesa
     * @return \StructType\GrabarDespacho4Response
     */
    public function setURLRemesa($uRLRemesa = null)
    {
        // validation for constraint: string
        if (!is_null($uRLRemesa) && !is_string($uRLRemesa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uRLRemesa)), __LINE__);
        }
        $this->URLRemesa = $uRLRemesa;
        return $this;
    }
    /**
     * Get IMGRelacionEnvio value
     * @return string|null
     */
    public function getIMGRelacionEnvio()
    {
        return $this->IMGRelacionEnvio;
    }
    /**
     * Set IMGRelacionEnvio value
     * @param string $iMGRelacionEnvio
     * @return \StructType\GrabarDespacho4Response
     */
    public function setIMGRelacionEnvio($iMGRelacionEnvio = null)
    {
        // validation for constraint: string
        if (!is_null($iMGRelacionEnvio) && !is_string($iMGRelacionEnvio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iMGRelacionEnvio)), __LINE__);
        }
        $this->IMGRelacionEnvio = $iMGRelacionEnvio;
        return $this;
    }
    /**
     * Get IMGRotulos value
     * @return string|null
     */
    public function getIMGRotulos()
    {
        return $this->IMGRotulos;
    }
    /**
     * Set IMGRotulos value
     * @param string $iMGRotulos
     * @return \StructType\GrabarDespacho4Response
     */
    public function setIMGRotulos($iMGRotulos = null)
    {
        // validation for constraint: string
        if (!is_null($iMGRotulos) && !is_string($iMGRotulos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iMGRotulos)), __LINE__);
        }
        $this->IMGRotulos = $iMGRotulos;
        return $this;
    }
    /**
     * Get IMGRemesa value
     * @return string|null
     */
    public function getIMGRemesa()
    {
        return $this->IMGRemesa;
    }
    /**
     * Set IMGRemesa value
     * @param string $iMGRemesa
     * @return \StructType\GrabarDespacho4Response
     */
    public function setIMGRemesa($iMGRemesa = null)
    {
        // validation for constraint: string
        if (!is_null($iMGRemesa) && !is_string($iMGRemesa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iMGRemesa)), __LINE__);
        }
        $this->IMGRemesa = $iMGRemesa;
        return $this;
    }
    /**
     * Get mensaje value
     * @return string|null
     */
    public function getMensaje()
    {
        return $this->mensaje;
    }
    /**
     * Set mensaje value
     * @param string $mensaje
     * @return \StructType\GrabarDespacho4Response
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensaje)), __LINE__);
        }
        $this->mensaje = $mensaje;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GrabarDespacho4Response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
