<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RelacionEnvioRespuesta StructType
 * @subpackage Structs
 */
class RelacionEnvioRespuesta extends AbstractStructBase
{
    /**
     * The numerodespacho
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $numerodespacho;
    /**
     * The solicitudrecogida
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $solicitudrecogida;
    /**
     * The remesas
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfRemesa
     */
    public $remesas;
    /**
     * The urlrelacionenvio
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $urlrelacionenvio;
    /**
     * The respuesta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Respuesta
     */
    public $respuesta;
    /**
     * Constructor method for RelacionEnvioRespuesta
     * @uses RelacionEnvioRespuesta::setNumerodespacho()
     * @uses RelacionEnvioRespuesta::setSolicitudrecogida()
     * @uses RelacionEnvioRespuesta::setRemesas()
     * @uses RelacionEnvioRespuesta::setUrlrelacionenvio()
     * @uses RelacionEnvioRespuesta::setRespuesta()
     * @param float $numerodespacho
     * @param string $solicitudrecogida
     * @param \ArrayType\ArrayOfRemesa $remesas
     * @param string $urlrelacionenvio
     * @param \StructType\Respuesta $respuesta
     */
    public function __construct($numerodespacho = null, $solicitudrecogida = null, \ArrayType\ArrayOfRemesa $remesas = null, $urlrelacionenvio = null, \StructType\Respuesta $respuesta = null)
    {
        $this
            ->setNumerodespacho($numerodespacho)
            ->setSolicitudrecogida($solicitudrecogida)
            ->setRemesas($remesas)
            ->setUrlrelacionenvio($urlrelacionenvio)
            ->setRespuesta($respuesta);
    }
    /**
     * Get numerodespacho value
     * @return float
     */
    public function getNumerodespacho()
    {
        return $this->numerodespacho;
    }
    /**
     * Set numerodespacho value
     * @param float $numerodespacho
     * @return \StructType\RelacionEnvioRespuesta
     */
    public function setNumerodespacho($numerodespacho = null)
    {
        $this->numerodespacho = $numerodespacho;
        return $this;
    }
    /**
     * Get solicitudrecogida value
     * @return string|null
     */
    public function getSolicitudrecogida()
    {
        return $this->solicitudrecogida;
    }
    /**
     * Set solicitudrecogida value
     * @param string $solicitudrecogida
     * @return \StructType\RelacionEnvioRespuesta
     */
    public function setSolicitudrecogida($solicitudrecogida = null)
    {
        // validation for constraint: string
        if (!is_null($solicitudrecogida) && !is_string($solicitudrecogida)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($solicitudrecogida)), __LINE__);
        }
        $this->solicitudrecogida = $solicitudrecogida;
        return $this;
    }
    /**
     * Get remesas value
     * @return \ArrayType\ArrayOfRemesa|null
     */
    public function getRemesas()
    {
        return $this->remesas;
    }
    /**
     * Set remesas value
     * @param \ArrayType\ArrayOfRemesa $remesas
     * @return \StructType\RelacionEnvioRespuesta
     */
    public function setRemesas(\ArrayType\ArrayOfRemesa $remesas = null)
    {
        $this->remesas = $remesas;
        return $this;
    }
    /**
     * Get urlrelacionenvio value
     * @return string|null
     */
    public function getUrlrelacionenvio()
    {
        return $this->urlrelacionenvio;
    }
    /**
     * Set urlrelacionenvio value
     * @param string $urlrelacionenvio
     * @return \StructType\RelacionEnvioRespuesta
     */
    public function setUrlrelacionenvio($urlrelacionenvio = null)
    {
        // validation for constraint: string
        if (!is_null($urlrelacionenvio) && !is_string($urlrelacionenvio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlrelacionenvio)), __LINE__);
        }
        $this->urlrelacionenvio = $urlrelacionenvio;
        return $this;
    }
    /**
     * Get respuesta value
     * @return \StructType\Respuesta|null
     */
    public function getRespuesta()
    {
        return $this->respuesta;
    }
    /**
     * Set respuesta value
     * @param \StructType\Respuesta $respuesta
     * @return \StructType\RelacionEnvioRespuesta
     */
    public function setRespuesta(\StructType\Respuesta $respuesta = null)
    {
        $this->respuesta = $respuesta;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RelacionEnvioRespuesta
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
