<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Remesa StructType
 * @subpackage Structs
 */
class Remesa extends AbstractStructBase
{
    /**
     * The numerocontrol
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $numerocontrol;
    /**
     * The numeroremesa
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $numeroremesa;
    /**
     * The urlremesa
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $urlremesa;
    /**
     * The urlrotulos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $urlrotulos;
    /**
     * The respuesta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Respuesta
     */
    public $respuesta;
    /**
     * Constructor method for Remesa
     * @uses Remesa::setNumerocontrol()
     * @uses Remesa::setNumeroremesa()
     * @uses Remesa::setUrlremesa()
     * @uses Remesa::setUrlrotulos()
     * @uses Remesa::setRespuesta()
     * @param string $numerocontrol
     * @param string $numeroremesa
     * @param string $urlremesa
     * @param string $urlrotulos
     * @param \StructType\Respuesta $respuesta
     */
    public function __construct($numerocontrol = null, $numeroremesa = null, $urlremesa = null, $urlrotulos = null, \StructType\Respuesta $respuesta = null)
    {
        $this
            ->setNumerocontrol($numerocontrol)
            ->setNumeroremesa($numeroremesa)
            ->setUrlremesa($urlremesa)
            ->setUrlrotulos($urlrotulos)
            ->setRespuesta($respuesta);
    }
    /**
     * Get numerocontrol value
     * @return string|null
     */
    public function getNumerocontrol()
    {
        return $this->numerocontrol;
    }
    /**
     * Set numerocontrol value
     * @param string $numerocontrol
     * @return \StructType\Remesa
     */
    public function setNumerocontrol($numerocontrol = null)
    {
        // validation for constraint: string
        if (!is_null($numerocontrol) && !is_string($numerocontrol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($numerocontrol)), __LINE__);
        }
        $this->numerocontrol = $numerocontrol;
        return $this;
    }
    /**
     * Get numeroremesa value
     * @return string|null
     */
    public function getNumeroremesa()
    {
        return $this->numeroremesa;
    }
    /**
     * Set numeroremesa value
     * @param string $numeroremesa
     * @return \StructType\Remesa
     */
    public function setNumeroremesa($numeroremesa = null)
    {
        // validation for constraint: string
        if (!is_null($numeroremesa) && !is_string($numeroremesa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($numeroremesa)), __LINE__);
        }
        $this->numeroremesa = $numeroremesa;
        return $this;
    }
    /**
     * Get urlremesa value
     * @return string|null
     */
    public function getUrlremesa()
    {
        return $this->urlremesa;
    }
    /**
     * Set urlremesa value
     * @param string $urlremesa
     * @return \StructType\Remesa
     */
    public function setUrlremesa($urlremesa = null)
    {
        // validation for constraint: string
        if (!is_null($urlremesa) && !is_string($urlremesa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlremesa)), __LINE__);
        }
        $this->urlremesa = $urlremesa;
        return $this;
    }
    /**
     * Get urlrotulos value
     * @return string|null
     */
    public function getUrlrotulos()
    {
        return $this->urlrotulos;
    }
    /**
     * Set urlrotulos value
     * @param string $urlrotulos
     * @return \StructType\Remesa
     */
    public function setUrlrotulos($urlrotulos = null)
    {
        // validation for constraint: string
        if (!is_null($urlrotulos) && !is_string($urlrotulos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlrotulos)), __LINE__);
        }
        $this->urlrotulos = $urlrotulos;
        return $this;
    }
    /**
     * Get respuesta value
     * @return \StructType\Respuesta|null
     */
    public function getRespuesta()
    {
        return $this->respuesta;
    }
    /**
     * Set respuesta value
     * @param \StructType\Respuesta $respuesta
     * @return \StructType\Remesa
     */
    public function setRespuesta(\StructType\Respuesta $respuesta = null)
    {
        $this->respuesta = $respuesta;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Remesa
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
