<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Respuesta StructType
 * @subpackage Structs
 */
class Respuesta extends AbstractStructBase
{
    /**
     * The codigo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $codigo;
    /**
     * The mensaje
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mensaje;
    /**
     * The codigointerno
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $codigointerno;
    /**
     * The mensajeinterno
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mensajeinterno;
    /**
     * Constructor method for Respuesta
     * @uses Respuesta::setCodigo()
     * @uses Respuesta::setMensaje()
     * @uses Respuesta::setCodigointerno()
     * @uses Respuesta::setMensajeinterno()
     * @param string $codigo
     * @param string $mensaje
     * @param string $codigointerno
     * @param string $mensajeinterno
     */
    public function __construct($codigo = null, $mensaje = null, $codigointerno = null, $mensajeinterno = null)
    {
        $this
            ->setCodigo($codigo)
            ->setMensaje($mensaje)
            ->setCodigointerno($codigointerno)
            ->setMensajeinterno($mensajeinterno);
    }
    /**
     * Get codigo value
     * @return string|null
     */
    public function getCodigo()
    {
        return $this->codigo;
    }
    /**
     * Set codigo value
     * @param string $codigo
     * @return \StructType\Respuesta
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: string
        if (!is_null($codigo) && !is_string($codigo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codigo)), __LINE__);
        }
        $this->codigo = $codigo;
        return $this;
    }
    /**
     * Get mensaje value
     * @return string|null
     */
    public function getMensaje()
    {
        return $this->mensaje;
    }
    /**
     * Set mensaje value
     * @param string $mensaje
     * @return \StructType\Respuesta
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensaje)), __LINE__);
        }
        $this->mensaje = $mensaje;
        return $this;
    }
    /**
     * Get codigointerno value
     * @return string|null
     */
    public function getCodigointerno()
    {
        return $this->codigointerno;
    }
    /**
     * Set codigointerno value
     * @param string $codigointerno
     * @return \StructType\Respuesta
     */
    public function setCodigointerno($codigointerno = null)
    {
        // validation for constraint: string
        if (!is_null($codigointerno) && !is_string($codigointerno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codigointerno)), __LINE__);
        }
        $this->codigointerno = $codigointerno;
        return $this;
    }
    /**
     * Get mensajeinterno value
     * @return string|null
     */
    public function getMensajeinterno()
    {
        return $this->mensajeinterno;
    }
    /**
     * Set mensajeinterno value
     * @param string $mensajeinterno
     * @return \StructType\Respuesta
     */
    public function setMensajeinterno($mensajeinterno = null)
    {
        // validation for constraint: string
        if (!is_null($mensajeinterno) && !is_string($mensajeinterno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensajeinterno)), __LINE__);
        }
        $this->mensajeinterno = $mensajeinterno;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Respuesta
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
